import java.util.Scanner;
import java.util.Stack;

/**
 * Created by chshru on 2017/11/4.
 */
public class J {

    public static void main(String[] args) {

        Scanner cin = new Scanner(System.in);
        while (cin.hasNextLine()) {
            System.out.println(calculate(cin.nextLine()));
        }
        cin.close();
    }

    private static String calculate(String s) {

        String[] data = s.split("\\s+");
        Stack<String> st = new Stack<>();
        for (String o : data) {
            if (o.equals("+") || o.equals("-") || o.equals("*") || o.equals("/")) {
                String b = st.pop();
                String a = st.pop();
                st.push(judge(a, o, b));
            } else {
                st.push(o);
            }
        }
        return st.peek().trim();
    }

    private static String judge(String a, String op, String b) {
        if (op.equals("+"))
            return String.valueOf(Integer.valueOf(a) + Integer.valueOf(b));
        if (op.equals("-"))
            return String.valueOf(Integer.valueOf(a) - Integer.valueOf(b));
        if (op.equals("*"))
            return String.valueOf(Integer.valueOf(a) * Integer.valueOf(b));
        return String.valueOf(Integer.valueOf(a) / Integer.valueOf(b));
    }
}
